#!/usr/bin/env python
# coding=UTF-8
import Image
import re
import os.path
import sys
import time
import traceback
import shutil

SOURCE_DIRECTORY = '/home/samba/storage/Обложки'
FULL_FILE_STORAGE_DIRECTORY = SOURCE_DIRECTORY + '/large'
REJECTED_DIRECTORY = SOURCE_DIRECTORY + '/rejected'
BASE_HEIGHT = 300 # Высота

assert os.path.isdir(SOURCE_DIRECTORY)
assert os.path.isdir(FULL_FILE_STORAGE_DIRECTORY)
assert os.path.isdir(REJECTED_DIRECTORY)

if __name__ == '__main__':
	lst = []
	for item in os.listdir(SOURCE_DIRECTORY):
		if os.path.isfile(os.path.join(SOURCE_DIRECTORY, item)) and re.match('.*\.jpe?g', item, re.IGNORECASE):
			lst.append(item)

	lst.sort()

	time.sleep(1) # Чтобы все недописанные файлы успели дописаться

	for filename in lst:
		baseheight = 300
		if not os.path.isfile(os.path.join(FULL_FILE_STORAGE_DIRECTORY, filename)):
			print 'resize', filename
			try:
				img = Image.open(os.path.join(SOURCE_DIRECTORY, filename))
				hpercent = (baseheight / float(img.size[1]))
				wsize = int((float(img.size[0]) * float(hpercent)))
				img = img.resize((wsize, baseheight), Image.ANTIALIAS)
				img.save(os.path.join(SOURCE_DIRECTORY, filename + '.small.jpg'))
				shutil.copy(
					os.path.join(SOURCE_DIRECTORY, filename),
					os.path.join(FULL_FILE_STORAGE_DIRECTORY, filename)
				)
				os.chmod(
					os.path.join(FULL_FILE_STORAGE_DIRECTORY, filename),
					0644
				)
				os.remove(
					os.path.join(SOURCE_DIRECTORY, filename)
				)
				os.rename(
					os.path.join(SOURCE_DIRECTORY, filename + '.small.jpg'),
					os.path.join(SOURCE_DIRECTORY, filename)
				)
			except:
				if os.path.isfile(os.path.join(REJECTED_DIRECTORY, filename)):
					os.remove(os.path.join(REJECTED_DIRECTORY, filename))
				os.rename(
					os.path.join(SOURCE_DIRECTORY, filename),
					os.path.join(REJECTED_DIRECTORY, filename)
				)
				with file(os.path.join(REJECTED_DIRECTORY, filename + '.txt'), 'wt') as f:
					f.write(traceback.format_exc())

